<?php
// $Id: dmtx.admin.inc,v 1.2 2008/10/14 08:22:03 arto Exp $

//////////////////////////////////////////////////////////////////////////////
// Settings form

function dmtx_admin_settings() {
  $form = array();

  $form['libdmtx'] = array('#type' => 'fieldset', '#title' => t('libdmtx settings'), '#collapsible' => TRUE, '#collapsed' => FALSE);
  $form['libdmtx']['dmtx_write'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Path to encoder'),
    '#default_value' => DMTX_WRITE,
    '#size'          => 60,
    '#maxlength'     => 255,
    '#required'      => TRUE,
    '#description'   => t('A file system path to the <code>dmtxwrite</code> binary. On Unix systems, this would typically be located at <code>/usr/bin/dmtxwrite</code> or <code>/usr/local/bin/dmtxwrite</code>. On Mac OS X with MacPorts, the path would typically be <code>/opt/local/bin/dmtxwrite</code>.'),
  );
  $form['libdmtx']['dmtx_read'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Path to decoder'),
    '#default_value' => DMTX_READ,
    '#size'          => 60,
    '#maxlength'     => 255,
    '#required'      => TRUE,
    '#description'   => t('A file system path to the <code>dmtxread</code> binary. On Unix systems, this would typically be located at <code>/usr/bin/dmtxread</code> or <code>/usr/local/bin/dmtxread</code>. On Mac OS X with MacPorts, the path would typically be <code>/opt/local/bin/dmtxread</code>.'),
  );

  return system_settings_form($form);
}

function dmtx_admin_settings_validate($form, &$form_state) {
  extract($form_state['values'], EXTR_SKIP | EXTR_REFS);

  if (!file_exists($dmtx_write)) {
    form_set_error('dmtx_write', t('The encoder path is invalid: %path not found.', array('%path' => $dmtx_write)));
  }

  if (!file_exists($dmtx_read)) {
    form_set_error('dmtx_read', t('The decoder path is invalid: %path no found.', array('%path' => $dmtx_read)));
  }
}
